require 'spec_helper'
require 'faraday'

describe 'test request' do
  it 'can be used as a convienence method' do
    faraday_response = Faraday::Response.new({
      :method => :get,
      :response_headers => {'content-type' => 'text/plain'},
      :body => 'foo',
      :url => 'http://foo.com'
    })

    Faraday::Connection.any_instance.stub(:get => faraday_response)

    response = ::Facile::Request.get do |req|
      req.url = 'http://foo.com'
    end

    expect(response.body).to eq('foo')
  end

  it 'can create request instance' do
    request = ::Facile::Request.new

    expect(request).to be_kind_of(::Facile::Request)
  end

  it 'can parse a response' do
    request = ::Facile::Request.new

    faraday_response = Faraday::Response.new({
      :method => :get,
      :response_headers => {'content-type' => 'text/plain'},
      :body => 'foo',
      :url => 'http://foo.com'
    })

    response = request.parse_response(faraday_response)

    expect(response).to be_kind_of(::Facile::Response)
    expect(response.body).to eq('foo')
  end
end
